#ifndef _other
#define _other

// Definitionen fr Befehlscodes
#define COMMAND_ZERO				0x00
#define COMMAND_SEND_ALL_DATA		0x01
#define COMMAND_LIVE_MODUS			0x02
#define COMMAND_LIVE_MODUS_STOP		0x03
#define COMMAND_RECEIVE_TIME		0x04
#define COMMAND_RECEIVE_ACK			0x05
#define COMMAND_PARAMETERS			0x06
#define COMMAND_STATUS_REQUEST		0x07
#define COMMAND_RESET				0x08
#define COMMAND_CALIBRATE			0x09
#define COMMAND_NEW_DATA			0x10
#define COMMAND_NEW_LINE			0x11
#define COMMAND_DATA_FINISH			0x12
#define COMMAND_NO_MORE_DATA		0x13
#define COMMAND_SEND_ACK			0x14
#define COMMAND_STATUS_RESPONSE		0x15
#define COMMAND_START				0xFF

// Definitionen fr Errorcodes
#define EC_NO_ERROR					0x00

#define EC_I2C_START				0x01		// I2C Errors immer mit 0x0? Errorcode
#define EC_I2C_SEND					0x02
#define EC_I2C_GET_ACK				0x03
#define EC_I2C_GET_NACK				0x04

#define EC_USART_SEND_ALL_DATA		0x11		// USART Errors immer mit 0x1? Errorcode
#define EC_USART_LIVE_MODUS			0x12
#define EC_USART_LIVE_MODUS_STOP	0x13
#define EC_USART_RECEIVE_TIME		0x14
#define EC_USART_RECEIVE_ACK		0x15
#define EC_USART_COMMAND_PARAMETERS 0x16
#define EC_USART_WRONG_CODE			0x17
#define EC_USART_WRONG_SEQ			0x18
#define EC_USART_NO_START			0x19
#define EC_USART_STATUS_REQUEST		0x1A
#define EC_USART_RESET				0x1B
#define EC_USART_WRONG_OLD_SEQ		0x1C
#define EC_USART_CALIBRATE			0x1D

#define EC_LIVE_WRONG_PACKET_TO		0x21		// Live Errors immer mit 0x2? Errorcode
#define EC_LIVE_TIMEOUT				0x22
#define EC_LIVE_WRONG_PACKAGES		0x23

#define EC_SPI_SEND_TIMEOUT			0x31		// SPI Errors immer mit 0x3? Errorcode
#define EC_SPI_TRANSMIT_TIMEOUT		0x32
#define EC_SPI_GET_TIMEOUT			0x33

struct time
{
	uint8_t seconds,minutes,hours,date,month,year;
};

extern uint8_t errorcode;						// Hier wird error-code gespeichert
extern uint32_t timeout_counter;				// Wird fr Timeouts benutzt
extern uint8_t resetbit;						// Gibt an ob Zurckgesetzt werden soll

uint32_t get_sec(struct time t);
uint8_t time_in_target_area(struct time rtc, struct time start, struct time end);
struct time rtc_values_to_bcd(struct time t);
struct time bcd_to_rtc_values(struct time t);
void programm_error(uint8_t error_code);

#endif
